#-*- coding: Utf-8 -*-
#Fonction

import time, sys

def puissance1(a,n):
    """retourne a^n avec un algorithme impératif
    """
    p = 1
    for i in range(n):
        p = a*p
    return p

def puissance2(a,n):
    """retourne a^n avec un algorithme récursif
    """
    if n == 0:
        return 1
    else:
        return a*puissance2(a,n-1)

def puissance3(a,n):

    """    fonction qui calcule a**n de façon recursive
    affichage des appels et sorties successifs de la fonction puissance"""
    
    if n == 0:
        return 1
    else:
        print('--'*n+'>appel de puissance(%s,%s)'%(a,n-1))
        p = a*puissance3(a,n-1)
        print('--'*n+'>sortie de puissance(%s,%s)'%(a,n-1))
        return p

    
def puissance4(a,n,acc):
    """retourne a^n avec une récursivité terminale 
    """
    if n == 0:
        return acc
    else:
        return puissance4(a,n-1,a*acc)

if __name__ == "__main__":
    sys.setrecursionlimit(5000)
    a = int(input('Entrez a : '))
    n = int(input('Entrez n : '))
    debut = time.clock()
    puissimp = puissance1(a,n)
    fin = time.clock()
    duree = fin - debut
    print('a^n par l\'algorithme impératif : %s en %.10f secondes'%(puissimp,duree))
    debut = time.clock()
    puissrec= puissance2(a,n)
    fin = time.clock()
    duree = fin - debut
    print('a^n par l\'algorithme récursif: %s en  %.10f secondes'%(puissrec,duree))
    debut = time.clock()
    puissrecterm = puissance4(a,n,1)
    fin = time.clock()
    duree = fin - debut
    print('a^n par l\'algorithme récursif terminal : %s en  %.10f secondes'%(puissrecterm ,duree))
    
    
    
    
    

            
        
    
    
            
