# -*- coding: utf-8 -*-
#######################
#       EXO 11        #
#######################


#Q1
def somme(a, b):
    """Retourne la somme des k**5 de a à b"""
    s = 0
    for k in range(a, b+1):
        s += k**5
    return s

#Q2 suite de l'algorithme de Héron d'approximation de sqrt(2)

def suite1(n):
    """Calcul du terme de rang n de u(0)=1 
    u(n+1)=1/2(u(n)+2/u(n))"""
    if n < 0:
        return None
    u = 1
    for k in range(1, n+1):
        u = 1/2.*(u + 2./u)
    return u

#Q3 suite récurrente u(n+1)=f(u(n), n)

import math

def suite2(n):
    """Calcul du terme de rang n de u(0)=1 
    u(n+1)=u(n)+sqrt(n)"""
    if n < 0:
        return None
    u = 1
    for k in range(1, n+1):
        u = u + math.sqrt(k - 1)
    return u

#Q4 suite récurrente u(n+1)=f(u(n), u(n-1))  ,suite de Fibonacci


def suite3(n):
    """Calcul du terme de rang n de f(0)=0 f(1)=1 
    f(n+2)=f(n+1)+f(n)"""
    if n < 0:
        return None
    v, u  = 0, 1
    if n == 0:
        return v
    for k in range(1, n+1):
        v, u  = u, u + v
    return u

"""
In [12]: [suite3(i) for i in range(-1, 10)]
Out[12]: [None, 0, 1, 2, 3, 5, 8, 13, 21, 34, 55]
"""
    
    
#Q5 suite de l'algorithme de Héron d'approximation de sqrt(2)

def suite4(n):
    """Calcul du terme de rang n de u(0)=1 
    u(n+1)=1/2(u(n)+2/u(n))"""
    if n < 0:
        return None
    u = 1
    for k in range(1, n+1):
        u = 1/2.*(u + 2./u)
    return u
#Q5 suite récurrente u(n+1)=f(u(n-1),u(n-2),n-2)

def suite1(n):
    """Calcul du terme de rang n de u(0)=1  u(1)=2
    u(n+2)=u(n+1)+n*u(n)"""
    v, u = 1, 2
    if n < 0:
        return None
    if n == 1:
        return v
    for k in range(2, n+1):
        v, u = u, u + (k-2)*v
    return u
    


    