# -*- coding: utf-8 -*-
#######################
#       EXO 12        #
#######################


#Q1
def echange(tab,i,j):
    """echange les valeurs des termes tab[i] et tab[j]
    du tableau t"""
    #on vérifie que i et j sont des entiers compris entre 0 et len(t)
    #sinon la fonction génère une erreur
    #facultatif
    assert isinstance(i,int) and isinstance(j,int) and 0<=i<len(t) and 0<=j<len(t)
    tab[i],tab[j] = tab[j],tab[i]
    #inutile de retourner t puisque les listes sont passées par référence

"""
>>> t=[i**3 for i in range(5)];t
[0, 1, 8, 27, 64]
>>> echange(t,1,2)
>>> t
[0, 8, 1, 27, 64]
"""

#Q2
def maximum(tab):
    """retourne le maximum d'un tableau, redéfinition de max"""
    m = tab[0]
    for terme in tab[1:]:
        if terme>m:
            m = terme
    return m

def position_maximum(tab):
    """retourne le maximum et la liste des positions où il est atteint"""
    tmaxi,maxi = [0],tab[0]
    for indice,terme in enumerate(tab):
        if terme>maxi:
            tmaxi,maxi = [indice],terme
        elif terme==maxi:
            tmaxi.append(indice)
    return tmaxi,maxi

"""
>>> from random import randint
>>> t=[randint(1,5) for i in range(10)]
>>> t
[4, 4, 1, 5, 5, 4, 2, 2, 1, 2]
>>> position_maximum(t)
([3, 4], 5)
"""


#Q3
def recherche_sequentielle(elt, tab):
    """Recherche sequentielle d'un element dans un tableau
    Reprogrammation de l'opérateur index
    """
    k = 0
    while k < len(tab) and tab[k] != elt:
        k += 1
    #si k < lent(tab), elt à la position k dans tab
    if k < len(tab):
        return k
    #sinon elt pas dans tab
    return None

from random import randint
tabalea = [randint(1, 6) for i in range(10)]
print(tabalea)
for j in range(1, 7):
    print('%s en position %s dans tabalea'%(j ,recherche_sequentielle(j, tabalea)))

"""
[2, 2, 3, 4, 3, 4, 1, 6, 4, 2]
1 en position 6 dans tabalea
2 en position 0 dans tabalea
3 en position 2 dans tabalea
4 en position 3 dans tabalea
5 en position None dans tabalea
6 en position 7 dans tabalea
>>> 
"""

#Q4
def inversion(tab):
    """retourne un tableau avec les éléments dans l'ordre inverse.
    Reprogrammation de la méthode reverse. """
    tabinv = []
    for terme in tab:
        #ou tabinv = [terme]+tabinv  qui récrée un nouvel objet liste
        tabinv.insert(0,terme)
    return tabinv

def inversion2(tab):
    """idem mais avec les propriétés du slicing Python"""
    return tab[-1::-1]

def inversion3(tab):
    """idem mais avec une liste en compréhension"""
    return [tab[i] for i in range(-1,-len(tab)-1,-1)]

"""
>>> t1
[10, 30, 42, 2, 17, 5, 30, -20]
>>> inversion(t1)
[-20, 30, 5, 17, 2, 42, 30, 10]
>>> inversion2(t1)
[-20, 30, 5, 17, 2, 42, 30, 10]
>>> inversion3(t1)
[-20, 30, 5, 17, 2, 42, 30, 10]
"""

#Q5
def somme(tab):
    """somme des éléments d'un tableau, redéfinition de sum"""
    s = 0
    for terme in tab:
        s += terme
    return s

"""
>>> somme([1,2,3])
6
"""

#Q6
def somme_ligne(tab):
    """retourne un tableau à une dimension avec les sommes de chaque ligne
    du tableau à deux dimensions passé en paramètre"""
    L = []
    for sline in map(somme,tab):
        L.append(sline)
    return L

def transpose(tab):
    """retourne la transposée d'un tableau : ses colonnes sont les lignes
    du tableau passé en paramètre"""
    return [[tab[j][i] for j in range(len(tab))] for i in range(len(tab[0]))]
    
def somme_colonne(tab):
    """retourne un tableau à une dimension avec les sommes de chaque ligne
    du tableau à deux dimensions passé en paramètre"""
    return somme_ligne(transpose(tab))
        
"""
>>> from random import randint
>>> t = [[randint(1,6) for i in range(3)] for j in range(4)]
>>> t
[[2, 4, 6], [3, 1, 3], [1, 1, 5], [5, 1, 3]]
>>> transpose(t)
[[2, 3, 1, 5], [4, 1, 1, 1], [6, 3, 5, 3]]
>>> somme_ligne(t)
[12, 7, 7, 9]
>>> somme_colonne(t)
[11, 7, 17]
"""

#Q7
def moyenne(tab):
    """moyenne des éléments d'un tableau sous forme de flottant"""
    return float(somme(tab))/len(tab)

#attention en Python2 la division de deux entiers retourne un entier
#pour obtenir le même comportement qu'en Python3 écrire au début du script
#from __future__ import division

def ecart_type1(tab):
    """écart-type des éléments d'un tableau avec la  formule de Konig"""
    tabcarre = [x**2 for x in tab]
    return (moyenne(tabcarre)-moyenne(tab)**2)**0.5

def ecart_type2(tab):
    """écart-type des éléments d'un tableau avec la définition et sans
    listes en compréhension"""
    m = moyenne(tab) #m est un flottant
    #s recevra la somme des carrés des écarts à la moyenne
    s = 0. #s sera un flottant
    for x in tab:
        s = s+(x-m)**2
    return (s/len(tab))**0.5

"""
#listes des carrés des entiers entre -3 et 5 compris
>>> t2 = [i**2 for i in range(-3,6)]
>>> moyenne(t2)
7.666666666666667
>>> ecart_type1(t2)
7.803133273813083
>>> ecart_type2(t2)
7.803133273813083
"""

#Q8
def sommes_cumulees(tab):
    """retourne les sommes cumulées de tab depuis le premier terme"""
    cumul = [tab[0]]
    naddition = 0
    for terme in tab[1:]:
        cumul.append(cumul[-1]+terme)
        naddition += 1
    return cumul,'%s additions'%naddition

"""
>>> t2 = [i**2 for i in range(-3,6)]
>>> sommes_cumulees(t2)
([9, 13, 14, 14, 15, 19, 28, 44, 69], '8 additions')
"""

#Q10
def ispalindrome(chaine):
    """détermine si une chaine est un palindrome"""
    l = len(chaine)
    #chaine inversée
    chaineinv  = ''
    for i in range(l-1,-1,-1):
        chaineinv += chaine[i]
    return chaine == chaineinv

#Q11
def est_anagramme(m1,m2):
    """teste si le mot m1 est anagramme de m2.
    On redéfiniti la fonction occurences pour traiter le ces des traits
    d'union"""
    def occurences2(chaine):
        chaine = chaine.lower() #on convertit la chaine en minuscules
        chaine = convert_accents(chaine) #conversion des caracteres accentues
        tab = [0]*27 
        #on crée un tableau de 26 zéros correspondant aux occurences
        #de chaque lettre
        for lettre in chaine:
            if 97<=ord(lettre)<=122:
                tab[ord(lettre)-97] += 1
            elif lettre=='-':
                tab[26] += 1
        return tab
        
    return occurences2(m1)==occurences2(m2)

"""
>>> est_anagramme('beausejour','jourseueba')
True
>>> est_anagramme('beausejour','jourseuebz')
False
>>> est_anagramme('beau-sejour','jourseueba')
False
>>> est_anagramme('beau-sejour','jo-urseueba')
True
"""