# -*- coding: utf-8 -*-

def positionp(m1,m2,p):
    """teste si le sous-mot m1 apparait dans m2 à la position p"""
    if p+len(m1)>len(m2):
        return False
    for i in range(len(m1)):
        if m1[i]!=m2[p+i]:
            return False
    return True

"""
>>> positionp('cadabra','abracadabra',4)
True
>>> positionp('cadabra','abracadabra',5)
False
>>> positionp('cadabra','abracadabra',0)
False
"""

def sousmot(m1,m2):
    """prenant en entrée deux chaînes de caractères m1 et m2 et
    retournant True ou False selon que m est un sous-mot de m2"""
    for p in range(len(m2)-len(m1)+1):
        if positionp(m1,m2,p):
            return True
    return False

"""
#On testera suivant quatre cas : absence, présence au bord gauche,
 au bord droit, et au milieu
>>> sousmot('su','sumo')
True
>>> sousmot('um','sumo')
True
>>> sousmot('mo','sumo')
True
>>> sousmot('uma','sumo')
False
"""

"""
#la fonction peut aussi s'appliquer aux listes
>>> sousmot([1,2],[1,2,3,4])
True
>>> sousmot([2,3],[1,2,3,4])
True
>>> sousmot([3,4],[1,2,3,4])
True
>>> sousmot([3,5],[1,2,3,4])
False
"""

def positions_sous_mot(m1,m2):
    """prend en entrée deux chaînes de caractères et retourne la liste
    (éventuellement vide) des positions dans m2 où on trouve le mot m1"""
    pos = [] #liste des positions
    for p in range(len(m2)-len(m1)+1):
        if positionp(m1,m2,p):
            pos.append(p)
    return pos

"""
>>> positions_sous_mot('ta','taratata')
[0, 4, 6]
"""

def recherche(fichier,mot,encodage='utf8'):
    """recherche la première occurence de mot
    dans le texte contenu dans un fichier texte.
    On ne traite pas le cas des mots coupés en fin de ligne."""
    f = open(fichier,'r',encoding=encodage)
    texte = f.read()
    ltexte = len(texte) #longueur du texte
    lmot = len(mot) #longueur du mot
    for i in range(ltexte-lmot+1):
        if texte[i] == mot[0]:
            test = True
            for j in range(1,lmot):
                if texte[i+j] != mot[j]:
                    test = False
                    break
            if test:
                return "La première occurence du mot %s est en position %s dans le fichier %s"%(mot,i,fichier)
    f.close()
    return None
                
        
def recherche2(fichier,mot,encodage='utf8'):
    """recherche la première occurence de mot
    dans le texte contenu dans un fichier texte.
    On ne traite pas le cas des mots coupés en fin de ligne."""
    f = open(fichier,'r',encoding=encodage)
    texte = f.read()
    ltexte = len(texte) #longueur du texte
    lmot = len(mot) #longueur du mot
    i = 0
    while i<ltexte-lmot+1:
        if texte[i] == mot[0]:
            test = True
            j = 0
            while j<lmot:
                if texte[i+j] != mot[j]:
                    test = False
                    break
                j += 1
            if test:
                return "La première occurence du mot %s est en position %s dans le fichier %s"%(mot,i,fichier)
        i += 1
    f.close()
    return None



def recherche3(fichier,mot,encodage='utf8'):
    """recherche la première occurence de mot
    dans le texte contenu dans un fichier texte.
    On ne traite pas le cas des mots coupés en fin de ligne."""
    f = open(fichier,'r',encoding=encodage)
    texte = f.read()
    ltexte = len(texte) #longueur du texte
    lmot = len(mot) #longueur du mot
    i = 0
    while i<ltexte-lmot+1:
        #on peut meme se passer du test texte[i] == mot[0]
        if texte[i] == mot[0]:
            j = 0
            while j<lmot and texte[i+j] == mot[j]:
                j += 1
            if j== len(mot):
                return "La première occurence du mot %s est en position %s dans le fichier %s"%(mot,i,fichier)
        i += 1
    f.close()
    return None

print(recherche('poeme_pi.txt','admirable',encodage='latin1'))
print(recherche2('poeme_pi.txt','admirable',encodage='latin1'))
print(recherche3('poeme_pi.txt','admirable',encodage='latin1'))
f = open('poeme_pi.txt','r',encoding='latin1')
texte = f.read()
l = len('admirable')
print(texte[236:236+l])
f.close()
