#-*- coding: Utf-8 -*-


#Q1 Factorielle
def factiter(n):
    """Retourne n!=1*2*;;*n avec un algorithme itératif"""
    if n < 0:
        return None
    f = 1
    for k in range(1, n+1):
        f *= k
    return f
    
def factrec(n):
    """Retourne n!=1*2*;;*n avec un algorithme récursif"""
    if n < 0:
        return None
    if n <= 1:
        return 1
    return n*factrec(n - 1)

"""
In [8]: [(factiter(n), factrec(n)) for n in range(-1, 5)]
Out[8]: [(None, None), (1, 1), (1, 1), (2, 2), (6, 6), (24, 24)]
"""

#Quotient de la division euclidienne

def quotientiter(a, b):
    """Retourne le quotient a//b par un algo itératif"""
    k = 0
    while a >= b:
        k += 1
        a -= b
    return k
            

def quotientrec(a, b):
    """Retourne le quotient a//b par un algo récursif"""
    if a < b:
        return 0
    return 1 + quotientrec(a - b, b)

"""
In [10]: [(quotientiter(10, k), quotientrec(10, k)) for k in range(1, 12)]
Out[10]: 
[(10, 10),
 (5, 5),
 (3, 3),
 (2, 2),
 (2, 2),
 (1, 1),
 (1, 1),
 (1, 1),
 (1, 1),
 (1, 1),
 (0, 0)]

In [11]: [(quotientiter(10, k), quotientrec(10, k), 10//k) for k in range(1, 12)]
Out[11]: 
[(10, 10, 10),
 (5, 5, 5),
 (3, 3, 3),
 (2, 2, 2),
 (2, 2, 2),
 (1, 1, 1),
 (1, 1, 1),
 (1, 1, 1),
 (1, 1, 1),
 (1, 1, 1),
 (0, 0, 0)]
"""

#Reste de la division euclidienne
def reste_iter(a, b):
    """Retourne le quotient a//b par un algo itératif"""
    while a >= b:
        a -= b
    return a
            

def reste_rec(a, b):
    """Retourne le quotient a//b par un algo récursif"""
    if a < b:
        return a
    return reste_rec(a - b, b)

"""
In [13]: [(reste_rec(10, k), reste_iter(10, k), 10%k) for k in range(1, 12)]
Out[13]: 
[(0, 0, 0),
 (0, 0, 0),
 (1, 1, 1),
 (2, 2, 2),
 (0, 0, 0),
 (4, 4, 4),
 (3, 3, 3),
 (2, 2, 2),
 (1, 1, 1),
 (0, 0, 0),
 (10, 10, 10)]
"""