#-*- coding: Utf-8 -*-
#Fonction

import time

def fiborec(n):
    """retourne le terme derang n de la suite de Fibonacci avec un algorithme récursif
    """
    if n == 0:
        return 1
    elif n == 1:
        return 1
    else:
        return fiborec(n-1)+fiborec(n-2)

def fibo(n):
    """retourne le terme derang n de la suite de Fibonacci avec un algorithme impératif
    """
    u = 1
    v = 1
    for i in range(1,n):
        s = u
        u = v
        v = s+v
    return v

def fiborecterm(n,acc1,acc2):
    """retourne le terme de rang n de la suite de Fibonacci avec une récursivité terminale
    """

    if n == 1:
        return acc2
    else:
        #print(n, ' ',acc1,' ',acc2)
        return fiborecterm(n-1,acc2,acc1+acc2)


if __name__ == "__main__":
    
    n = int(input('Entrez n : '))
    debut = time.clock()
    fibo_imp = fibo(n)
    fin = time.clock()
    duree = fin - debut
    print('Fn par l\'algorithme impératif : %s en %.8f secondes'%(fibo_imp,duree))
    debut = time.clock()
    fibo_rec= fiborec(n)
    fin = time.clock()
    duree = fin - debut
    print('Fn par l\'algorithme récursif: %s en  %.8f secondes'%(fibo_rec,duree))
    debut = time.clock()
    fibo_recterm = fiborecterm(n,1,1)
    fin = time.clock()
    duree = fin - debut
    print('Fn par l\'algorithme récursif terminal : %s en  %.8f secondes'%(fibo_recterm,duree))  
    
    
    
    
    

            
        
    
    
            
