#-*- coding: Utf-8 -*-


#Q1 Exponentiation rapide 
def exporapiderec(a, n):
    """Exponentiation rapide version récursive"""
    if n == 0:
        return 1
    if n%2 == 0:
        return exporapiderec(a, n//2)**2
    return a*exporapiderec(a, (n-1)//2)**2

def exporapideiter(a, n):
    """Exponentiation rapide version itérative
    On décompose l'exposant n en base 2 et on multiplie
    par les puissances de 2 apparaissant dans la décomposition
    Par exemple pour 3**7 on écrit 3**(1+2+2**2)
    """
    puissance = 1
    accu = a
    while n > 0:
        if n%2 == 1:
            puissance *= accu
        accu = accu**2
        n = n//2
    return puissance

"""
In [28]: [(2**k, exporapideiter(2, k), exporapiderec(2, k)) for k in range(10)]
Out[28]: 
[(1, 1, 1),
 (2, 2, 2),
 (4, 4, 4),
 (8, 8, 8),
 (16, 16, 16),
 (32, 32, 32),
 (64, 64, 64),
 (128, 128, 128),
 (256, 256, 256),
 (512, 512, 512)]
"""