#-*- coding: Utf-8 -*-


#Q1 Suite recurrente recursive
#u(0) = 2 u(n+1) = u(n) + 2*n

def suite1_iter(n):
    if n < 0:
        return None
    u = 2
    for k in range(1, n+1):
        u = u + 2*(k-1)
    return u


def suite1_rec(n):
    if n < 0:
        return None
    if n == 0:
        return 2
    return suite1_rec(n-1) + 2*(n-1)
    
"""
In [41]: [(suite1_iter(k), suite1_rec(k), 10%k) for k in range(1, 12)]
Out[41]: 
[(2, 2, 0),
 (4, 4, 0),
 (8, 8, 1),
 (14, 14, 2),
 (22, 22, 0),
 (32, 32, 4),
 (44, 44, 3),
 (58, 58, 2),
 (74, 74, 1),
 (92, 92, 0),
 (112, 112, 10)]
"""

#Q2 suite u(0) = 2 et u(n+1)=1/2*(u(n)+3/u(n))


def suite2_iter(n):
    if n < 0:
        return None
    u = 2
    for k in range(1, n+1):
        u = 1/2.*(u + 3./u)
    return u


def suite2_rec(n):
    if n < 0:
        return None
    if n == 0:
        return 1
    #ne pas oublier de capturer suite1_rec(n-1)
    #dans une variable pour éviter de faire deux appels
    #on appelle cette opération factorisation
    preced = suite2_rec(n-1)
    return 1/2.*(preced + 3./preced)

"""
#Convergence vers sqrt(3)
In [51]: [(suite2_iter(k), suite2_rec(k)) for k in range(1, 12)]
Out[51]: 
[(1.75, 2.0),
 (1.7321428571428572, 1.75),
 (1.7320508100147274, 1.7321428571428572),
 (1.7320508075688772, 1.7320508100147274),
 (1.7320508075688772, 1.7320508075688772),
 (1.7320508075688772, 1.7320508075688772),
 (1.7320508075688772, 1.7320508075688772),
 (1.7320508075688772, 1.7320508075688772),
 (1.7320508075688772, 1.7320508075688772),
 (1.7320508075688772, 1.7320508075688772),
 (1.7320508075688772, 1.7320508075688772)]
"""
 
#Q3
import math

def suite3_iter(tab):
    res = 0
    #on parcours le tableau de la fin au début
    for k in range(len(tab) - 1, -1, -1):
        res = math.sqrt(tab[k] + res)
    return res


def suite3_rec(tab, n):
    if n == len(tab) - 1:
        return tab[n]
    return math.sqrt(tab[n] + suite3_rec(tab, n +1))
    
"""

In [61]: tab = [k for k in range(10)]

In [62]: suite3_iter(tab), suite3_rec(tab, 0)
Out[62]: (1.325870171062976, 1.3258738621062631)
"""