# -*- coding: utf-8 -*-

"""Variations autour du module time
Documentation du module :
http://docs.python.org/3.3/library/time.html
Attention la date minimale manipulable avec le module time 
est le 01/01/1970 et la date maximale dépend des plateformes
mais se trouve aux alentours de 2038 pour un système 32 bits.
Pour manipuler plus facilement des date hors de cette zone, utiliser
le module datetime  http://docs.python.org/3.3/library/datetime.html#module-datetime
"""

from time import*


def chrono(n):
	"""affiche le temps écoulé depuis le début au format POSIX
	en nombre de secondes écoulées depuis l'epoch UNIX 01/01/1970.
	Affiche le temps écoulé depusi le début à intervale de 1 seconde puis affiche 
	c'est fini au-delà de n secondes
	"""
	debut = time()
	actu = debut
	#debut, actu =  (time(),)*2
	while actu< debut+n:
		sleep(1)
		actu = time()
		print("Le jeu est commencé depuis %s secondes"%(int(actu-debut)))
	print("C'est fini !")


def noel():
	"""Affiche le nombre de jours restant avant 
	le prochain Noel"""
	presentPOSIX = localtime()
	annee = presentPOSIX.tm_year
	noelPOSIX = strptime("25/12/%s"%annee,"%d/%m/%Y")
	ecart = noelPOSIX.tm_yday - presentPOSIX.tm_yday
	if ecart >0:
		print('Il reste %s jours avant Noel en cette année %s'%(ecart,annee))
	else:
		print('Noel est passé depuis %s jours en cette année %s'%(-ecart,annee))
	
	
def vendredi13():
	"""Affiche le nombre de jours avant le prochain vendredi 13"""
	jour = 0
	present = time()
	presentPOSIX = localtime()
	#present, preentPOSIX = time(), localtime()
	while presentPOSIX.tm_wday !=4:
		jour += 1
		present += 24*60*60 #on avance d'un jour
		presentPOSIX = localtime(present) #on recupère la structure temps de present au format POSIX
	#si l vendredi suivant est un vendredi 13
	if presentPOSIX.tm_mday == 13:
		reponse = strftime('Le prochain vendredi 13 aura lieu le vendredi %d %B %Y',presentPOSIX)
		reponse = reponse+',ce sera dans %s joursd'%jour
		print(reponse)
	#sinon on avance par incrémentation d'une semaine jusqu'au prochain vendredi 13
	else:
		while presentPOSIX.tm_mday != 13:
			jour += 7
			present += 7*24*60*60 #on avance d'une semaine
			presentPOSIX = localtime(present) #on recupère la structure temps de present au format POSIX
		reponse = strftime('Le prochain vendredi 13 aura lieu le vendredi %d %B %Y',presentPOSIX)
		reponse = reponse+', ce sera dans %s jours.'%jour
		print(reponse)
			
def il_y_a(evenement):
	"""Affiche le nombre de jours
	écoulés depuis la date d'un certain événement au format 'J/M/AAAA'
	et le jour de la semaine correspondant où il s'est produit.
	Ne marche pas pour les dates avant l'EPOCH UNIX, 01/01/1970
	"""
	datePOSIX = strptime(evenement,'%d/%m/%Y')
	jour = strftime('%A',datePOSIX)
	dateEPOCH = mktime(datePOSIX)
	present = time()
	print("L'événement s'est produit il y a %s jours, c'était un %s."%((present-dateEPOCH)//(24*60*60),jour))
			
		
	
if __name__ == "__main__":
	#chrono(5)
	#noel()
	vendredi13()
	#Sacre de Charlemagne : le 25/12/800  cf http://fr.wikipedia.org/wiki/Charlemagne
	il_y_a('23/04/2008')
