#-*- coding: Utf-8 -*

#on définit d'abord plusieurs fonctions

def affichage1(matrice):
    """ligne par ligne de haut en bas et de gauche à droite pour chaque ligne"""
    for i in range(len(matrice)):
        for j in range(len(matrice[i])):
                print(matrice[i][j], ' ',end='')
        print('')

def affichage2(matrice):
    """colonne  par colonne de grauche à droite et de haut en bas pour chaque colonne
    ne fonctionne que si toutes les colonnes ont le même taille qui est len(matrice[0])"""
    for j in range(len(matrice[0])):
        for i in range(len(matrice)):
            print(matrice[i][j], ' ',end='')
        print('')


def moyenne(matrice):
    dim = len(matrice)*len(matrice[0])
    somme = 0
    for i in range(len(matrice)):
        for j in range(len(matrice[i])):
            somme += matrice[i][j]
    return somme/dim

def scalaire_matrice(matrice,scalaire):
    """multiplie tous les coefficients de matrice par un scalaire
    la variable  passée dans le paramètre matrice est de type liste,
    elle est passée par référence donc elle est modifiée par la fonction"""
    for i in range(len(matrice)):
        for j in range(len(matrice[0])):
            matrice [i][j] *= scalaire
    #on n'utilise un return  parce qu'un calcul retorune un résultat en général
    return matrice

def scalaire_matrice2(matrice,scalaire):
    """une variante en important le module mathématique numpy
    et son type de tableau array. Les objets de type array supportent
    des opératiosn vectorialisées. Multiplier un array par un scalaire 
    revient à multiplier tous ses coefficienst par le scalaire."""
    import numpy as np
    tableau = np.array(matrice)
    #du coup la matrice passée en paramètre n'est pas modifiée
    return scalaire*tableau
        
def reinitialise(matrice):
    """réinitialise la matrice m en assignant  None à tous ses coefficients.
    la variable  passée dans le paramètre matrice est de type liste,
    elle est passée par référence donc elle est modifiée par la fonction"""
    for i in range(len(matrice)):
        for j in range(len(matrice[0])):
            matrice [i][j] = None
    
def zeros1(n,m):
    """retourne une matrice de n lignes et m colonnes remplie de zéros"""
    matrice = []
    for i in range(n):
        matrice.append([])
        for j in range(m):
            matrice[i].append(0)
    return matrice
    
def zeros2(n,m):
    """retourne une matrice de n lignes et m colonnes remplie de zéros"""
    matrice = []
    for i in range(n):
        matrice.append([0]*m)
    return matrice

def zeros3(n,m):
    """retourne une matrice de n lignes et m colonnes remplie de zéros"""
    return [[0 for j in range(m)] for i in range(n)]

def test_fonction_zeros(fonction,ligne,colonne):
    """Vérifie si la fonction retorune bien une matrice de dimensions 
    lignexcolonnes remplies de 0 sans recyclage de lignes identiques"""
    print('Test de la fonction %s'%fonction.__name__)
    a = fonction(ligne,colonne)
    #on recopie les valeurs dees lignes de a dans b
    #les noms de variables a et b ne pointeront pas vers les mêmes données
    b = [a[i][:] for i in range(len(a))]
    b [1][1] = 2
    #c est un alias de a, meme chose que pour c = a[:] pour une liste à 2 dimensions
    c = a
    c [1][1] = 3
    print('a et b sont des alias donc ils partagent les mêmes données, b est une vraie copie de a')
    print('Si b est modifiée a ne l\'est pas ')
    print('a',a,'b',b,'c',c,sep='\n')
    print('Nouveau test ou fin \n')

#programme principal

#matrice des notes 
m = [[12,9,13,10],[10,14,12,8],[15,16,17,7]]
print('Affichage par ligne ')
affichage1(m)
print('Affichage par colonne')
affichage2(m)
print('Moyenne annuelle : %.2f'%moyenne(m))
print('On augmente toutes les notes de 10 \% !!!')
print(scalaire_matrice2(m,1.1))
print(scalaire_matrice(m,1.1))
print('m a été modifiée par la fonction scalaire_matrice : \n ',m)
print('Nouvelle moyenne augmentée de 10\%','évidemment : %.2f'%moyenne(m))
print()
ligne,colonne = eval(input('Entrez un couple d\'entiers ligne,colonne : '))
for fonction in [zeros1,zeros2,zeros3]:
    test_fonction_zeros(fonction,ligne,colonne)
