#-*- coding: Utf-8 -*

"""Ce programme détermine un encadrement
du nombre d'Euler e avec un algorithme de dichotomie."""

import math  #import du module de fonctions mathématiques 

#définitions des fonctions

def f(x):
    """x es tun flottant, retourne f(x)
    où f strictement croissante
    et s'annulant une fois """
    return math.log(x)-1

def dichotomie(a,b,p):
    """a,b et p des flottants
    retourne l'encadrement d'amplitude p  de la solution
    de f(x) =0 dans [a;b] par l'algorithme de dichotomie"""  
    while math.fabs(b-a)>p:
        m = (a+b)/2
        if f(m)<0:
            a = m
        else:
            b = m
    return a,b

#Programme principal

binf = float(input('Entrez la borne inférieure : '))
bsup = float(input('Entrez la borne supérieure : '))
amplitude = float(input('Entrez l\'amplitude souhaitée : ')) 
print('La solution de f(x)=0 sur [%s,%s]'
      'est encadrée par [%s]'%(binf,bsup,dichotomie(binf,bsup,amplitude)))
print('Une valeur approchée de e à 0,000001 près est %.6f'%math.e)




        

    
    
